/********************************************************************
 *	ԂԂ
 ********************************************************************
 */
#include <string.h>
#include "spi2.h"

void _MIPS32 wait_125ns(int ns);


/********************************************************************
 *	( ms ) * 1mS ҂.
 ********************************************************************
 */
void _MIPS32 wait_ms(int ms)
{
	int i;
	for(i=0; i<ms; i++) {
		wait_125ns(1000*8);
	}
}

/********************************************************************
 *	( us ) * 1uS ҂.
 ********************************************************************
 */
void _MIPS32 wait_us(int us)
{
	wait_125ns(us*8);
}
/********************************************************************
 *	( us * 1/8 ) uS ҂. clock=72MHzƉ.
 ********************************************************************
 */
//clock=48MHzƉ.	œKIvVRpCςČv.
void _MIPS32 wait_125ns(int ns)
{
	int i;
	for(i=0; i<ns; i++) {
		asm("nop");
	}
}
/********************************************************************
 *	
 ********************************************************************
 */
void _MIPS32 wait_0us(void)
{
}

/********************************************************************
 *	codëߖ
 ********************************************************************
 */
void *memcpy(void *dst,const void *src,size_t size)
{
	char *t = (char*)dst;
	char *s = (char*)src;
	while(size--) {*t++=*s++;}
	return t;
}

/********************************************************************
 *	codëߖ
 ********************************************************************
 */
void *memset(void *dst,int data,size_t size)
{
	char *t = (char*)dst;
	while(size--) {*t++=data;}
	return t;
}

#ifdef	USE_INTERNAL_FRC_OSC	// RC OSC
/********************************************************************
 * Function:	Clock Select to FRC
 *******************************************************************/
void InitializeFRC()
{
	mSysUnlockOpLock( 
		{PPSOutput(3, RPA4, REFCLKO);}
	);

	OSCREFConfig(OSC_REFOCON_FRC,
	OSC_REFOCON_OE | OSC_REFOCON_ON, 1);

	mSysUnlockOpLock(
		{OSCCONbits.NOSC = 3; //ECPLL
		 OSCCONbits.OSWEN = 1;}
	);

	while(OSCCONbits.COSC != 3);

	SYSTEMConfigPerformance(40000000);

}
#endif

