#ifndef	_sampling_h
#define	_sampling_h

#include "utype.h"

//! 	TvOp[^\.
typedef struct {
// 	--------------------------------------------------
	uchar  cmd;			//!< +00				SAMPLING
	uchar  subcmd;		//!< +01 = a/d;		a=1 d=2 stop=0
	ushort size;		//!< +02 = count;		1040
	uint   rate;		//!< +04 = rate;		1000(sample/sec)
// 	--------------------------------------------------
	ushort channels;	//!< +08	ch(s)  = channels(1..16) 1(chs)
	uchar  port_sel;	//!< +0a				0(port)
	uchar  reserve[5];	//!< +0b
// 	--------------------------------------------------
} SAMPLE_PARAM;			//!<  16bytes

//! 	Tv^[wb_[.
typedef struct {
// 	--------------------------------------------------
	uchar  cmd;			//!< +00				SAMPLING
	uchar  subcmd;		//!< +01 = a/d;		a=1 d=2 stop=0
	ushort size;		//!< +02 = count;		1040
	uint   rate;		//!< +04 = rate;		1000(sample/sec)
// 	--------------------------------------------------
	uchar  reserve[3];	//!< +08
	uchar  overrun;		//!< +0b
	uint   debug_cnt;	//!< +0c
// 	--------------------------------------------------
} SAMPLE_RETURN;			//!<  16bytes

//! 	SAMPLE_PARAMsubcmdtB[h̒l.
enum {
	ADC_STOP,
	ADC_ANALOG,
	ADC_DIGITAL,
};

//! 	t@[EFÅ֐.
int	sample_init(SAMPLE_PARAM *param);	//!< TvOJn.
int	sample_stop();						//!< TvO~.
int	sample_read(int *buf,int size);	//!< TvOf[^擾.

int		sample_start(SAMPLE_PARAM *param);
void	fifo_init();
void	SetAnalog(int pin);
void	analogInit(int rate,int channels);
void	analogStop(void);

#endif
